/*
   $Id: tm-au.cmd,v 1.3 1995/09/15 05:55:58 H.Ueno Exp $
*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

address 'cmd'
parse arg request, rest
parse var request tmpfile mtype msubtype action filename .

share='OS2ENVIRONMENT'
/*-----------------------------------------------------------------------*/
/*  determine a directory where a temporary file will be placed          */
/*-----------------------------------------------------------------------*/
savedir=value('TM_TMP_DIR',,share)
if savedir='' then savedir=value('TMP',,share)
if savedir='' then savedir='.'

/*-----------------------------------------------------------------------*/
/*  determine a viewer for audio                                         */
/*-----------------------------------------------------------------------*/
viewer=value('TM_VIEW_AU',,share)
if viewer='' then viewer='ab'

select
    when mtype='audio/basic' then
        uvenv='TM_VIEW_AU_BASIC'
    when mtype='audio/x-aiff' then
        uvenv='TM_VIEW_AU_AIFF'
    when mtype='audio/x-wav' then
        uvenv='TM_VIEW_AU_WAV'
end

uviewer=value(uvenv,,share)
if uviewer<>'' then viewer=uviewer

/*-----------------------------------------------------------------------*/
/*  translate any '/' characters to '\' here.                            */
/*-----------------------------------------------------------------------*/
tmpfile=translate(tmpfile,'\','/')

/*-----------------------------------------------------------------------*/
/*  build a filename to be created from the temporary file.              */
/*-----------------------------------------------------------------------*/
if filename='' | filename='""' then do
    select
        when mtype='audio/basic' then do
            filename=SysTempFileName(savedir'\mime????.au')
            end
        when mtype='audio/x-aiff' then do
            filename=SysTempFileName(savedir'\mime????.aif')
            end
        when mtype='audio/x-wav' then do
            filename=SysTempFileName(savedir'\mime????.wav')
            end
        otherwise
            filename=SysTempFileName(savedir'\mime????.au')
    end
end
else
    filename=savedir'\'filename

call tmdecode msubtype, tmpfile, filename, savedir
call SysFileDelete(tmpfile)

/*-----------------------------------------------------------------------*/
/*  perform a requested action.                                          */
/*-----------------------------------------------------------------------*/
select
    when action='play' then do
        viewer filename
        end
    when action='extract' then do
        say 'extract to ' filename
        exit 0
        end
    otherwise
        say 'unknown action: ' action
        call SysFileDelete(filename)
        exit -1
end

call SysFileDelete(filename)
