/*
   $Id: tm-image.cmd,v 1.51 1995/09/15 05:43:50 H.Ueno Exp $
*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

address 'cmd'
parse arg request, rest
parse var request tmpfile mtype msubtype action filename .

share='OS2ENVIRONMENT'
/*-----------------------------------------------------------------------*/
/*  determine a directory where a temporary file will be placed          */
/*-----------------------------------------------------------------------*/
savedir=value('TM_TMP_DIR',,share)
if savedir='' then savedir=value('TMP',,share)
if savedir='' then savedir='.'

/*-----------------------------------------------------------------------*/
/*  determine a viewer for image                                         */
/*-----------------------------------------------------------------------*/
viewer=value('TM_VIEW_IMAGE',,share)
if viewer='' then viewer='pmjpeg'

select
    when mtype='image/gif' then
        uvenv='TM_VIEW_IMAGE_GIF'
    when mtype='image/jpeg' then
        uvenv='TM_VIEW_IMAGE_JPEG'
    when mtype='image/tiff' | mtype='image/x-tiff' then
        uvenv='TM_VIEW_IMAGE_TIFF'
    when mtype='image/x-xbm' then
        uvenv='TM_VIEW_IMAGE_XBM'
    when mtype='image/x-pic' then
        uvenv='TM_VIEW_IMAGE_PIC'
    when mtype='image/x-pcx' then
        uvenv='TM_VIEW_IMAGE_PCX'
    when mtype='image/x-portable-pixmap' then
        uvenv='TM_VIEW_IMAGE_PPM'
    when mtype='image/x-portable-graymap' then
        uvenv='TM_VIEW_IMAGE_PGM'
    when mtype='image/x-os2-bmp' then
        uvenv='TM_VIEW_IMAGE_BMP'
end

uviewer=value(uvenv,,share)
if uviewer<>'' then viewer=uviewer

/*-----------------------------------------------------------------------*/
/*  translate any '/' characters to '\' here.                            */
/*-----------------------------------------------------------------------*/
tmpfile=translate(tmpfile,'\','/')

/*-----------------------------------------------------------------------*/
/*  build a filename to be created from the temporary file.              */
/*-----------------------------------------------------------------------*/
if filename='' | filename='""' then do
    select
        when mtype='image/gif' then do
            filename=SysTempFileName(savedir'\mime????.gif')
            end
        when mtype='image/jpeg' then do
            filename=SysTempFileName(savedir'\mime????.jpg')
            end
        when mtype='image/tiff' | mtype='image/x-tiff' then do
            filename=SysTempFileName(savedir'\mime????.tif')
            end
        when mtype='image/x-xbm' then do
            filename=SysTempFileName(savedir'\mime????.xbm')
            end
        when mtype='image/x-pic' then do
            filename=SysTempFileName(savedir'\mime????.pic')
            end
        when mtype='image/x-pcx' then do
            filename=SysTempFileName(savedir'\mime????.pcx')
            end
        when mtype='image/x-portable-pixmap' then do
            filename=SysTempFileName(savedir'\mime????.ppm')
            end
        when mtype='image/x-portable-graymap' then do
            filename=SysTempFileName(savedir'\mime????.pgm')
            end
        when mtype='image/x-os2-bmp' then do
            filename=SysTempFileName(savedir'\mime????.bmp')
            end
        otherwise
            filename=SysTempFileName(savedir'\mime????.img')
    end
end
else
    filename=savedir'\'filename

call tmdecode msubtype, tmpfile, filename, savedir
call SysFileDelete(tmpfile)

/*-----------------------------------------------------------------------*/
/*  perform a requested action.                                          */
/*-----------------------------------------------------------------------*/
select
    when action='play' then do
        viewer filename
        call SysFileDelete(filename)
        end
    when action='extract' then do
        say 'extract to ' filename
        end
end
