/*
   $Id: tm-mpeg.cmd,v 1.4 1995/09/15 05:46:05 H.Ueno Exp $
*/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

address 'cmd'
parse arg request, rest
parse var request tmpfile mtype msubtype action filename .

share='OS2ENVIRONMENT'
/*-----------------------------------------------------------------------*/
/*  determine a directory where a temporary file will be placed          */
/*-----------------------------------------------------------------------*/
savedir=value('TM_TMP_DIR',,share)
if savedir='' then savedir=value('TMP',,share)
if savedir='' then savedir='.'

/*-----------------------------------------------------------------------*/
/*  determine a viewer for video                                         */
/*-----------------------------------------------------------------------*/
viewer=value('TM_VIEW_VIDEO',,share)
if viewer='' then viewer='pmmpeg'

select
    when mtype='video/mpeg' then
        uvenv='TM_VIEW_VIDEO_MPEG'
    when mtype='video/x-msvideo' then
        uvenv='TM_VIEW_VIDEO_AVI'
    when mtype='video/quicktime' then
        uvenv='TM_VIEW_VIDEO_MOV'
end

uviewer=value(uvenv,,share)
if uviewer<>'' then viewer=uviewer

/*-----------------------------------------------------------------------*/
/*  translate any '/' characters to '\' here.                            */
/*-----------------------------------------------------------------------*/
tmpfile=translate(tmpfile,'\','/')

/*-----------------------------------------------------------------------*/
/*  build a filename to be created from the temporary file.              */
/*-----------------------------------------------------------------------*/
if filename='' | filename='""' then do
    select
        when mtype='video/mpeg' then do
            filename=SysTempFileName(savedir'\mime????.mpg')
            end
        when mtype='video/x-msvideo' then do
            filename=SysTempFileName(savedir'\mime????.avi')
            end
        when mtype='video/quicktime' then do
            filename=SysTempFileName(savedir'\mime????.mov')
            end
        otherwise
            filename=SysTempFileName(savedir'\mime????.mpg')
    end
end
else
    filename=savedir'\'filename

call tmdecode msubtype, tmpfile, filename, savedir
call SysFileDelete(tmpfile)

/*-----------------------------------------------------------------------*/
/*  perform a requested action.                                          */
/*-----------------------------------------------------------------------*/
select
    when action='play' then do
        viewer filename
        end
    when action='extract' then do
        say 'extract to ' filename
        exit 0
        end
end

call SysFileDelete(filename)
